
### Setting paths

The U-Net3D from MLPerf has no version control.


```
MODEL_NAME=U-Net3D
MODEL_BASE=/proj/nsc_testing/xuan/containers/pytorch_1.7.1-cuda11.0-cudnn8-runtime.sif
CONTAINER_DIR=/proj/nsc_testing/xuan/containers/${MODEL_NAME}.sif
DEF_DIR=/proj/nsc_testing/xuan/berzelius-benchmarks/MLPerf/training/image_segmentation/pytorch//${MODEL_NAME}.def
WORK_DIR=/proj/nsc_testing/xuan/berzelius-benchmarks/MLPerf/training/image_segmentation/pytorch
```
### Building the container

```
apptainer build $MODEL_BASE  docker://pytorch/pytorch:1.7.1-cuda11.0-cudnn8-runtime
apptainer build $CONTAINER_DIR $DEF_DIR
```


### Downloading and preprocessing the data

```
cd $WORK_DIR
git clone https://github.com/neheller/kits19
apptainer exec $CONTAINER_DIR bash -c "cd kits19 && python3 -m starter_code.get_imaging"
mv kits19/data/* raw-data/
rm -rf kits19

apptainer exec --nv -B ${WORK_DIR}/raw-data:/raw-data -B ${WORK_DIR}/data:/data -B ${WORK_DIR}/results:/results $CONTAINER_DIR bash -c "cd /workspace/unet3d && python3 preprocess_dataset.py --data_dir /raw-data --results_dir /data"
```



### Running benchmarking 

```
apptainer exec --nv -B ${WORK_DIR}/raw-data:/raw-data -B ${WORK_DIR}/data:/data -B ${WORK_DIR}/results:/results $CONTAINER_DIR bash -c "cd /workspace/unet3d && bash run_and_time.sh 1"
```

### Running benchmarking using batch jobs

```
bash submit_benchmark_jobs.sh
```

### Known issues

#### Issue 1

The line 23 in `main.py` will try to create a file in the container `/workspace/unet3d`, which will cause a write permission issue. We comment out this line.