#!/bin/bash

SBATCH_DIR=$WORK_DIR/sbatch_scripts/benchmark_${6}_${5}_dim${1}_nodes${2}_gpus${3}_batchsize_${4}.sbatch
SBATCH_OUT_DIR=$WORK_DIR/sbatch_out/benchmark_${6}_${5}_dim${1}_nodes${2}_gpus${3}_batchsize_${4}.out
LOG_DIR=benchmark_${6}_${5}_dim${1}_nodes${2}_gpus${3}_batchsize_${4}.log

cat <<EOT >  $SBATCH_DIR
#!/bin/bash

#SBATCH -A nsc
#SBATCH --nodes=${2}
#SBATCH --gpus=${3}
#SBATCH --time=0-0:20:00
#SBATCH --output=$SBATCH_OUT_DIR

EOT

if [ "${6}" = "thin" ]; then
    cat <<EOT >>  $SBATCH_DIR
#SBATCH -C "thin"    
#SBATCH --reservation=$GPU_RESERVATION
EOT
else
    cat <<EOT >>  $SBATCH_DIR
#SBATCH -C "fat"
EOT
fi

cat <<EOT >>  $SBATCH_DIR

rm -f $WORK_DIR/results/$LOG_DIR
apptainer exec --nv -B ${WORK_DIR}/raw-data:/raw-data -B ${WORK_DIR}/data:/data -B ${WORK_DIR}/results:/results $CONTAINER_DIR bash -c "cd /workspace/unet3d && bash run_and_time.sh 1"

mv ${WORK_DIR}/results/unet3d.log ${WORK_DIR}/results/$LOG_DIR

EOT
